class PermutationBase {

  int drawType;
  float posX;
  float posY;

  float posOrigX;
  float posOrigY;
  PVector moveDir;
  float damp = 0.6;
  float gForce = 4;
  float gForcePush = 2;
  float gForceHome = .06;

  int version = 1;
  int fillMode = 0;
  float shapeSize = 30;
  float newShapeSize = shapeSize;


  //form1 pictures
  PShape image1;
  PShape image2;
  PShape image3;
  PShape image4;
  PShape image5;
  PShape image6;
  PShape image7;
  PShape image8;
  PShape image9;
  PShape image10;

  //form2 pictures
  PShape image11;
  PShape image12;
  PShape image13;
  PShape image14;
  PShape image15;
  PShape image16;
  PShape image17;
  PShape image18;
  PShape image19;
  PShape image20;

  //form3 pictures
  PShape image21;
  PShape image22;
  PShape image23;
  PShape image24;
  PShape image25;
  PShape image26;
  PShape image27;
  PShape image28;
  PShape image29;
  PShape image30;
  
  //form4 pictures
  PShape image31;
  PShape image32;
  PShape image33;
  PShape image34;
  PShape image35;
  PShape image36;
  PShape image37;
  PShape image38;
  PShape image39;
  PShape image40;
  
  //form5 pictures
  PShape image41;
  PShape image42;
  PShape image43;
  PShape image44;
  PShape image45;
  PShape image46;
  PShape image47;
  PShape image48;
  PShape image49;
  PShape image50;
  
  //form6 pictures
  PShape image51;
  PShape image52;
  PShape image53;
  PShape image54;
  PShape image55;
  PShape image56;
  PShape image57;
  PShape image58;
  PShape image59;
  PShape image60;
  
  //form7 pictures
  PShape image61;
  PShape image62;
  PShape image63;
  PShape image64;
  PShape image65;
  PShape image66;
  PShape image67;
  PShape image68;
  PShape image69;
  PShape image70;
  
  
  


  ///////////////////////////////////////////////////////////////////////


  PermutationBase(float x, float y, int drawType) {

    posX = x;
    posY = y;
    posOrigX = x;
    posOrigY = y;
    moveDir = new PVector(0, 0);
    drawType = drawType;

    //form1 load pictures
    image1 = loadShape("./images/form1/image_1.svg");
    image2 = loadShape("./images/form1/image_2.svg");
    image3 = loadShape("./images/form1/image_3.svg");
    image4 = loadShape("./images/form1/image_4.svg");
    image5 = loadShape("./images/form1/image_5.svg");
    image6 = loadShape("./images/form1/image_6.svg");
    image7 = loadShape("./images/form1/image_7.svg");
    image8 = loadShape("./images/form1/image_8.svg");
    image9 = loadShape("./images/form1/image_9.svg");
    image10 = loadShape("./images/form1/image_10.svg");

    //form2 load pictures
    image11 = loadShape("./images/form2/image_1.svg");
    image12 = loadShape("./images/form2/image_2.svg");
    image13 = loadShape("./images/form2/image_3.svg");
    image14 = loadShape("./images/form2/image_4.svg");
    image15 = loadShape("./images/form2/image_5.svg");
    image16 = loadShape("./images/form2/image_6.svg");
    image17 = loadShape("./images/form2/image_7.svg");
    image18 = loadShape("./images/form2/image_8.svg");
    image19 = loadShape("./images/form2/image_9.svg");
    image20 = loadShape("./images/form2/image_10.svg");

     /*
    //form3 load pictures
    image21 = loadShape("./images/form3/image_1.svg");
    image22 = loadShape("./images/form3/image_2.svg");
    image23 = loadShape("./images/form3/image_3.svg");
    image24 = loadShape("./images/form3/image_4.svg");
    image25 = loadShape("./images/form3/image_5.svg");
    image26 = loadShape("./images/form3/image_6.svg");
    image27 = loadShape("./images/form3/image_7.svg");
    image28 = loadShape("./images/form3/image_8.svg");
    image29 = loadShape("./images/form3/image_9.svg");
    image30 = loadShape("./images/form3/image_10.svg");
     **/
    /*
    //form4 load pictures
    image31 = loadShape("./images/form4/image_1.svg");
    image32 = loadShape("./images/form4/image_2.svg");
    image33 = loadShape("./images/form4/image_3.svg");
    image34 = loadShape("./images/form4/image_4.svg");
    image35 = loadShape("./images/form4/image_5.svg");
    image36 = loadShape("./images/form4/image_6.svg");
    image37 = loadShape("./images/form4/image_7.svg");
    image38 = loadShape("./images/form4/image_8.svg");
    image39 = loadShape("./images/form4/image_9.svg");
    image40 = loadShape("./images/form4/image_10.svg");
    **/
    
    /*
    
    //form5 load pictures
    image41 = loadShape("./images/form5/image_1.svg");
    image42 = loadShape("./images/form5/image_2.svg");
    image43 = loadShape("./images/form5/image_3.svg");
    image44 = loadShape("./images/form5/image_4.svg");
    image45 = loadShape("./images/form5/image_5.svg");
    image46 = loadShape("./images/form5/image_6.svg");
    image47 = loadShape("./images/form5/image_7.svg");
    image48 = loadShape("./images/form5/image_8.svg");
    image49 = loadShape("./images/form5/image_9.svg");
    image50 = loadShape("./images/form5/image_10.svg");
    
    **/
    
    //form6 load pictures
    image51 = loadShape("./images/form6/image_1.svg");
    image52 = loadShape("./images/form6/image_2.svg");
    image53 = loadShape("./images/form6/image_3.svg");
    image54 = loadShape("./images/form6/image_4.svg");
    image55 = loadShape("./images/form6/image_5.svg");
    image56 = loadShape("./images/form6/image_6.svg");
    image57 = loadShape("./images/form6/image_7.svg");
    image58 = loadShape("./images/form6/image_8.svg");
    image59 = loadShape("./images/form6/image_9.svg");
    image60 = loadShape("./images/form6/image_10.svg");
    
    
    //form7 load pictures
    image61 = loadShape("./images/form7/image_1.svg");
    image62 = loadShape("./images/form7/image_2.svg");
    image63 = loadShape("./images/form7/image_3.svg");
    image64 = loadShape("./images/form7/image_4.svg");
    image65 = loadShape("./images/form7/image_5.svg");
    image66 = loadShape("./images/form7/image_6.svg");
    image67 = loadShape("./images/form7/image_7.svg");
    image68 = loadShape("./images/form7/image_8.svg");
    image69 = loadShape("./images/form7/image_9.svg");
    image70 = loadShape("./images/form7/image_10.svg");
    
  }




  void update(int x, int y, int mButton) {
    PVector curPos = new PVector(posX, posY);
    PVector homeDir = new PVector(0, 0);

    if (mButton == LEFT) { // Objekte anziehen 
      PVector gCenter = new PVector(x, y);
      PVector gDir = PVector.sub(gCenter, curPos);

      gDir.normalize();
      gDir.mult(gForce);  

      moveDir.add(gDir);
    } 

    else if (mButton == RIGHT) { // Objekte abstossen
      PVector gCenter = new PVector(x, y);
      PVector gDir = PVector.sub(curPos, gCenter);

      gDir.normalize();
      gDir.mult(gForcePush);  

      moveDir.add(gDir);
    }

    else { // an Ursprungsposition zurückkehren (go Home)
      homeDir = new PVector(posOrigX, posOrigY);
      homeDir.sub(curPos);

      if (homeDir.mag() > 1.5) {
        homeDir.mult(gForceHome);
      }
      else {
        homeDir.set(0, 0);
      }
    }


    curPos.add(moveDir); // Bewegungsverktoren hinzufügen
    curPos.add(homeDir); // ''

    posX = curPos.x;
    posY = curPos.y;

    moveDir.mult(damp);
  }


  void draw() {
    switch(version) {
    case 1:
      form1();
      break;

    case 2:
      form2();
      break;

    case 3:
      form3();
      break;
      
    case 4:
      form4();
      break;
      
    case 5:
      form5();
      break;
      
    case 6:
      form6();
      break;
      
    case 7:
      form7();
      break;
    }

    if (sizeMode == 0) newShapeSize = shapeSize;
    if (sizeMode == 1) newShapeSize = shapeSize*1.5-map(dist(mouseX, mouseY, posX, posY), 0, 500, 5, shapeSize);
    if (sizeMode == 2) newShapeSize = map(dist(mouseX, mouseY, posX, posY), 0, 500, 5, shapeSize);
  }



  void form1() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image1, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image2, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image3, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image4, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image5, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image6, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image7, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image8, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image9, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image10, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }


  void form2() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image11, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image12, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image13, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image14, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image15, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image16, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image17, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image18, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image19, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image20, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }


  void form3() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image21, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image22, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image23, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image24, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image25, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image26, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image27, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image28, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image29, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image30, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }
  
  
    void form4() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image31, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image32, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image33, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image34, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image35, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image36, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image37, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image38, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image39, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image40, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }
  
  
  void form5() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image41, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image42, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image43, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image44, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image45, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image46, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image47, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image48, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image49, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image50, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }
  
  
  void form6() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image51, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image52, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image53, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image54, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image55, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image56, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image57, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image58, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image59, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image60, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }
  
  
   void form7() {
    pushStyle();

    translate(posX, posY);

    switch(drawType) {
    case 0:
      ellipse(0, 0, newShapeSize, newShapeSize);
      break;

    case 1:
      shape(image61, 0, 0, newShapeSize, newShapeSize); 
      break;

    case 2:
      shape(image62, 0, 0, newShapeSize, newShapeSize);
      break;

    case 3:
      shape(image63, 0, 0, newShapeSize, newShapeSize);
      break;

    case 4:
      shape(image64, 0, 0, newShapeSize, newShapeSize);
      break;

    case 5:
      shape(image65, 0, 0, newShapeSize, newShapeSize);
      break;

    case 6:
      shape(image66, 0, 0, newShapeSize, newShapeSize);
      break;

    case 7:
      shape(image67, 0, 0, newShapeSize, newShapeSize);
      break;

    case 8:
      shape(image68, 0, 0, newShapeSize, newShapeSize);
      break;

    case 9:
      shape(image69, 0, 0, newShapeSize, newShapeSize);
      break;

    case 10:
      shape(image70, 0, 0, newShapeSize, newShapeSize);
      break;

    default:
      break;
    }
    popStyle();
  }
}

